package com.example.InvioAllegatoMailTrap;

import java.io.*;
import java.util.Properties;
import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.*;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.servlet.http.*;
import javax.servlet.annotation.*;

@WebServlet(name = "inviaServlet", value = "/invia")
public class InviaServlet extends HttpServlet {
    public void init() {
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        out.println("<html><body>");

        // Aggiungere nel file pom.xml le seguenti dipendenze (vedere il file pom.xml di questo progetto)
        //      javax.mail:mail:1.4.7
        //      javax.activation:activation:1.1.1
        //
        // Quindi selezionare il pulsante "Load Maven Changes"

        // Aggiungere al file WEB-INF/web.xml un "security-constraint" per limitare l'accesso
        // alla cartella "private".
        // (Vedere il file WEB-INF/web.xml di questo progetto)

        // Credenziali di accesso al server smtp.mailtrap.io
        final String login ="******";
        final String password ="******";

        final String mittente ="no-reply@example.com";
        final String destinatario ="mario.rossi@example.com";


        try {
            // Parametri di connessione al server SMTP
            Properties props = new Properties();
            props.setProperty("mail.host", "smtp.mailtrap.io");
            props.setProperty("mail.smtp.port", "2525");
            props.setProperty("mail.smtp.auth", "true");
            props.setProperty("mail.smtp.starttls.enable", "true");
            props.setProperty("mail.smtp.ssl.protocols", "TLSv1.2 TLSv1.3");
            props.setProperty("mail.mime.charset", "UTF-8");

            // Autenticazione basata su login/password
            Authenticator auth = new Authenticator() {
                @Override
                public PasswordAuthentication getPasswordAuthentication() {
                    return new PasswordAuthentication(login, password);
                }
            };

            // Acquisizione di una sessione Mail
            Session session = javax.mail.Session.getInstance(props, auth);

            // Preparazione del messaggio con allegato
            MimeMessage msg = new MimeMessage(session);

            // Impostazione di mittente, destinatario e oggetto
            msg.setFrom(new InternetAddress(mittente));
            msg.addRecipient(Message.RecipientType.TO, new InternetAddress(destinatario));
            msg.setSubject("Messaggio di prova da Java Mail");

            // Per allegare un file occorre generare un messaggio Multipart:
            // nella prima parte si memorizza il messaggio, nella seconda il file allegato

            Multipart multipart = new MimeMultipart();

            BodyPart parte1 = new MimeBodyPart();
            parte1.setHeader("Content-Type", "text/plain; charset=UTF-8");
            parte1.setHeader("Content-Transfer-Encoding", "quoted-printable");

            parte1.setText("Questo è un messaggio di prova.");
            multipart.addBodyPart(parte1);

            // Part two is attachment
            BodyPart parte2 = new MimeBodyPart();

            String filename = "prova.pdf";;
            String filepath = request.getServletContext().getRealPath("private/" + filename);;
            DataSource source = new FileDataSource(filepath);
            parte2.setDataHandler(new DataHandler(source));
            parte2.setFileName(filename);
            multipart.addBodyPart(parte2);

            // Aggiunge il contenuto multipart al messaggio
            msg.setContent(multipart);

            // Invia il messaggio
            Transport.send(msg);
            out.println(String.format("Messaggio inviato correttamente a %s.", destinatario));

        } catch (Exception ex) {
            System.out.println(ex.getMessage());
            ex.printStackTrace(out);
        }
        out.println("</body></html>");
    }

    public void destroy() {
    }
}